void SetCommandPointer();
void (*PuntatoreFunzione[200])();
char PuntatoreIngressi[10];

void Com_StringLength();
void Com_TurnOnLed();
void Com_TurnOffLed();
void Com_LedBlink();
void Com_Loop();
void Com_Delay();
void Com_CheckInput1();
void Com_CheckInput0();
void Com_CheckInputRegister();
void Com_SetOutput();
void Com_ResetOutput();
void Com_SetOutputRegister();
void Com_ResetOutputRegister();
void Com_TurnOnGSM();
void Com_AutomaticCallReply();
void Com_TurnOffGSM();
void Com_SendSMS();
void Com_ReadSMS();
void Com_DeleteSMS();
void Com_SendCall();
void Com_WaitIncommingCall();
void Com_StringMerge();
void Com_IntToString();
void Com_CopyString();
void Com_FindString();
void Com_CutString();
void Com_LoadStringDirect();
void Com_LoadString();
void Com_StoreStringDirect();
void Com_StoreString();
void Com_StringMerge();
void Com_IntToString();
void Com_LoadRegister();
void Com_StoreRegister();
void Com_LoadRegisterDirect();
void Com_StoreRegisterDirect();
void Com_ConstantToRegister();
void Com_Sum();
void Com_Subtraction();
void Com_Division();
void Com_Multiplication();
void Com_OR();
void Com_AND();
void Com_IfEqual();
void Com_IfGreater();
void Com_IfMinor();
void Com_TurnOnRS232USB();
void Com_TurnOffRS232USB();
void Com_txRS232USB();
void Com_rxRS232USB();
void Com_PowerDown();
void Com_TimerON();
void Com_TimerOFF();
void Com_CheckCallState();
void Com_ReplyCall();
void Com_CloseCall();
void Com_CheckBattery();
void Com_BeepBuzzer();
void Com_AnalogInput();
void Com_LoadVectorRegister();
void Com_StoreVectorRegister();
void Com_LoadVectorString();
void Com_StoreVectorString();
void Com_ProductionTest();


//----------------------------------------------------- L E D   F U N C T I O N ---------------------------------------------------------------------------

//************************************************************ Turn ON LED ********************************************************************************
#define LED_ON 0
#define COMMAND.LED.LED_ON "LED Turn ON"()-OUTPUT.LEDOn
//*********************************************************** Turn OFF LED ********************************************************************************
#define LED_OFF 1
#define COMMAND.LED.LED_OFF "LED Turn OFF"()-OUTPUT.LEDOff
//************************************************************ Blink LED **********************************************************************************
#define BLINK 2
#define COMMAND.LED.BLINK "LED Blink"()-OUTPUT.LEDBlink


//*************************************************************** Jump ************************************************************************************
//PARAMETER
//16 bit: Jump destination address
#define GOTO 10
#define COMMAND.JUMP.GOTO "Jump to state"(J16_1"Jump target state address"){State to jump=J16_1}-JUMP.Goto


//************************************************************** SLEEP ************************************************************************************
//PARAMETER
//8 bit: Index of the register that contains the delay value (msec)
#define SLEEP_MS 20
#define COMMAND.DELAY.SLEEP_MS "Delay ms"(RIn_1"8 bit: Index of the register that contains the delay value (ms)"){Delay=RIn_1}-OUTPUT.Delay
//---------------------------------------------------------------------------------------------------------------------------------------------------------


//---------------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------- I N P U T / O U T P U T   F U N C T I O N -----------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------------------------------------------------------

//*********************************************************** Check Input *********************************************************************************
//PARAMETER
//8 bit [I]:  Input selector.     1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5, 6:Switch1, 7:Switch2
//8 bit [I]:  Input control mode. 0: Check if the input value is '1' (without debounce),
//                                1: Check if the input value is '1' (with debounce),
//                                2: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds.
//                                3: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds with beep.
//16 bit [I]: Jump address if input is '1'.
//16 bit [I]: Jump address if input stays at '1' for more that 2 seconds.
#define CHECK_INPUT_1 30
#define COMMAND.IO.CHECK_INPUT_1 "Test if the Input = 1"(In8_1(1:Input1, 2:Input2, 3:Input3, 4:Input4, 5:Input5, 6:Switch1, 7:Switch2)"Select the input to be checked", In8_2(0:Check if input is '1' without debounce, 1:Check if input is '1' with debounce, 2:Check if input is '1' and if it stays '1' for more than 2 seconds, 3:Check if input is '1' and if it stays '1' for more than 2 seconds with beep)"8 bit: Input control mode. 0: Return the input value, 1: Check if the input value is '1' (with debounce), 2: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds, 3: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds with beep.", J16_1"Jump address if input is 1",J16_2"Jump address if input stays at 1 for more that 2 seconds"){Check input In8_1<br>Type of control=In8_2<br>if IN In8_1=1<br>Jump to J16_1<br>if IN In8_1=1 for more 2 seconds<br>Jump to J16_2}-JUMP.Input

//*********************************************************** Check Input *********************************************************************************
//PARAMETER
//8 bit [I]:  Input selector.     1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5, 6:Switch1, 7:Switch2
//8 bit [I]:  Input control mode. 0: Check if the input value is '0' (without debounce),
//                                1: Check if the input value is '0' (with debounce),
//                                2: Check if the input value is '0' (with debounce) and stays at '0' for more than 2 seconds.
//                                3: Check if the input value is '0' (with debounce) and stays at '0' for more than 2 seconds with beep.
//16 bit [I]: Jump address if input is '0'.
//16 bit [I]: Jump address if input stays at '0' for more that 2 seconds.
#define CHECK_INPUT_0 31
#define COMMAND.IO.CHECK_INPUT_0 "Test if the Input = 0"(In8_1(1:Input1, 2:Input2, 3:Input3, 4:Input4, 5:Input5, 6:Switch1, 7:Switch2)"Select the input to be checked",In8_2(0:Check if input is '0' without debounce, 1:Check if input is '0' with debounce, 2:Check if input is '0' and if it stays '0' for more than 2 seconds, 3:Check if input is '1' and if it stays '1' for more than 2 seconds with beep)"8 bit: Input control mode. 0: Return the input value, 1: Check if the input value is '0' (with debounce), 2: Check if the input value is '0' (with debounce) and stays at '0' for more than 2 seconds, 3: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds with beep.",J16_1"Jump address if input is 0",J16_2"Jump address if input stays at 0 for more that 2 seconds"){Check input In8_1<br>Type of control=In8_2<br>if IN In8_1=0<br>Jump to J16_1<br>if IN In8_1=0 for more 2 seconds<br>Jump to J16_2}-JUMP.Input0

//*********************************************************** Check Input *********************************************************************************
//PARAMETER
//8 bit [R]:  Input selector register. 1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5, 6:Switch1, 7:Switch2
//8 bit [I]:  Input control mode. 0: Return the input value,
//                                1: Check if the input value is '1' (with debounce),
//                                2: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds.
//                                3: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds with beep.
//8 bit [R]:  Index of the destination register where the input value will be stored.
//            Register will be set to the input value ('0' or '1') when the Input control mode is set to '0' or '1'.
//            Register will be set to '2' if the the input stays at '1' for more than 2 seconds when the Input control mode is set to '2' or '3'.
#define CHECK_INPUT_REGISTER 32
#define COMMAND.IO.CHECK_INPUT_REGISTER "Save Input to register"(RIn_1"8 bit: Index of the input selector register. 1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5, 6:Switch1, 7:Switch2",In8_1(0:Return the input value, 1:Check if input is '1' with debounce, 2:Check if input is '1' and if it stays at '1' for more than 2 seconds, 2:Check if input is '1' and if it stays at '1' for more than 2 seconds with beep)"8 bit: Input control mode. 0: Return the input value, 1: Check if the input value is '1' (with debounce), 2: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds, 3: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds with beep.",ROut_1"Index of the destination register where the input value will be stored. Register will be set to the input value ('0' or '1') when the Input control mode is set to '0' or '1'. Register will be set to '2' if the the input stays at '1' for more than 2 seconds when the Input control mode is set to '2' or '3'."){Check input RIn_1<br>Type of control=RIn_2<br>ROut_1=input value}-JUMP.Input

//*********************************************************** Set Output *********************************************************************************
//PARAMETER
//8 bit [I]:  Output selector.    1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5
//            The selected output will be set to '1'.
#define SET_OUT 33
#define COMMAND.IO.SET_OUT "Set the selected Output to '1'"(In8_1(1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5, 6: Alim CTRL)"Select the Output line to set"){OUT In8_1=1}-OUTPUT.OutputOn

//********************************************************* Reset Output *********************************************************************************
//PARAMETER
//8 bit [I]:  Output selector.    1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5
//            The selected output will be reset to '0'.
#define RESET_OUT 34
#define COMMAND.IO.RESET_OUT "Reset the selected Output to '0'"(In8_1(1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5, 6: Alim CTRL)"Select the Output line to reset"){OUT In8_1=0}-OUTPUT.OutputOff

//*********************************************************** Set Output *********************************************************************************
//PARAMETER
//8 bit [R]:  Index of the Output selector register. 1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5
//            The selected output will be set to '1'.
#define SET_OUT_REGISTER 35
#define COMMAND.IO.SET_OUT_REGISTER "Set the selected (by a register) Output to '1'"(RIn_1"8 bit: Index of the Output selector register. 1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5. The selected output will be set to '1'."){OUT RIn_1=1}-OUTPUT.OutputOn

//********************************************************* Reset Output *********************************************************************************
//PARAMETER
//8 bit [R]:  Index of the Output selector register. 1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5
//            The selected output will be reset to '0'.
#define RESET_OUT_REGISTER 36
#define COMMAND.IO.RESET_OUT_REGISTER "Reset the selected (by a register) Output to '0'"(RIn_1"8 bit: Index of the Output selector register. 1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5. The selected output will be reset to '0'."){OUT RIn_1=0}-OUTPUT.OutputOff

//--------------------------------------------------------------------------------------------------------------------------------------------------------

//********************************************************* Analog Input *********************************************************************************
//PARAMETER
//8 bit [I]:  Analog Input selector. 1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5
//8 bit [I]:  Input Range selector: 0: 0-12V  input range (resolution = 17,9mV)
//            						1: 0-3.3V input range (resolution = 3,2mV)
//8 bit [R]:  Index of the destination register where the Analog value will be stored (in mV)
#define ANALOG_INPUT 37
#define COMMAND.IO.ANALOG_INPUT "Read Analog Input value."(In8_1(1:Input1, 2:Input2, 3:Input3, 4:Input4, 5:Input5)"Analog Input selector",In8_2(0: 0-12V input range, 1: 0-3.3V input range)"Input Range selector. 0: 0-12V analog input range (resolution 17.9mV), 1: 0-3.3V analog input range (3.2mV resolution)",ROut_1"Index of the destination register where the Analog value will be stored (in mV). The value is in mV."){Read analog input In8_1<br>Type of control=In8_2<br>ROut_1= analog input In8_1}-OUTPUT.AnalogInput


//---------------------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------ G S M   F U N C T I O N --------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------------------------------------------------------

//********************************************************* Turn ON GSM **********************************************************************************
//PARAMETER
//8 bit that contains the index of Registro where save the state of GSM
//Store 0 in Registro if all is OK
//Store 1 in Registro if not is possible to connect to GSM central
//Store 2 in Registro if there are problem to comunicate with GSM module
#define GSM_ON 50
#define COMMAND.GSM.GSM_ON "GSM turn ON"(ROut_1"index of Registro where save the state of GSM. 0 all OK, 1 not possible to connect to GSM central, 2 problem to comunicate with GSM module"){ROut_1=State of GSM<br>0 all OK<br>1 not possible to connect to GSM central<br>2 problem to comunicate with GSM module}-OUTPUT.GSMOn
//********************************************************* Turn OFF GSM **********************************************************************************
#define GSM_OFF 51
#define COMMAND.GSM.GSM_OFF "GSM turn OFF"()-OUTPUT.GSMOff
//*********************************************************** Send SMS ************************************************************************************
//PARAMETER
//8 bit that contains SMS type: 0=standard sms, 1=flash sms
//16 bit address of memory where read the number to send SMS
//16 bit address of memory where read the text message
#define SEND_SMS 52
#define COMMAND.GSM.SEND_SMS "Send SMS"(In8_1(0:standard SMS, 1:flash SMS)"SMS type: 0=standard sms, 1=flash sms",MemIn_1"16 bit address of memory where read the number to send SMS",MemIn_2"16 bit address of memory where read the text message"){SMS Type=In8_1<br>Number phone=[MemIn_1]<br>Text=[MemIn_2]}-OUTPUT.SendSMS
//*********************************************************** Read SMS ************************************************************************************
//PARAMETER
//8 bit that contains index of Registro where read the SMS position to read
//16 bit address of memory where store the SMS readed
//8 bit that contains index of Registro where store the SMS state (0=readed, 1=unread)
//16 bit address of memory where store the number of SMS readed
//8 bit that contains type of read.if 0 read the SMS and exit. If 1 read SMS and exit, but if not exist SMS, wait in infinite loop to receive SMS
//8 bit that contains index of Registro where store the state of reading. 0=message readed, 1=message not readed
#define READ_SMS 53
#define COMMAND.GSM.READ_SMS "Read SMS"(RIn_1"index of Registro where read the SMS position to read",MemOut_1"16 bit address of memory where store the SMS readed",ROut_1"index of Registro where store the SMS state (0=readed, 1=unread)",MemOut_2"16 bit address of memory where store the number of SMS readed",In8_1(0:read and exit, 1:wait SMS)"type of read.if 0 read the SMS and exit. If 1 read SMS and exit, but if not exist SMS, wait in infinite loop to receive SMS",ROut_2"index of Registro where store the state of reading. 0=message readed, 1=message not readed"){SMS Position=RIn_1<br>SMS Readed=[MemOut_1]<br>SMS State=ROut_1<br>Phone Number=[MemOut_2]<br>Read Type=In8_1}-JUMP.ReadSMS
//*********************************************************** Delete SMS ************************************************************************************
//PARAMETER
//8 bit that contains index of Registro where read the SMS position to delete
//8 bit that contains index of Registro where store the state of deleting. 0=message deleted, 1=message not deleted
#define DELETE_SMS 54
#define COMMAND.GSM.DELETE_SMS "Delete SMS"(RIn_1"index of Registro where read the SMS position to delete",ROut_1"index of Registro where store the state of deleting. 0=message deleted, 1=message not deleted"){Delete message at address RIn_1<br>ROut_1=Delete state}-OUTPUT.DeleteSMS
//*********************************************************** Send Call ************************************************************************************
//PARAMETER
//16 bit that contains seconds to wait repply call
//16 bit that contains seconds to take active call
//8 bit that contains max number of call if not repply
//16 bit address of memory where read number to call
//8 bit that contains index of Registro where save state of sending call. Store 0 in Registro if not reply to call, 1 if receive call and stay active all seconds setting in second parameter, 2 if receive call but called off by remote user
#define SEND_CALL 55
#define COMMAND.GSM.SEND_CALL "Send call"(In16_1"seconds to wait repply call",In16_1"seconds to take active call",In8_1"max number of call if not repply",MemIn_1"16 bit address of memory where read number to call",ROut_1"index of Registro where save state of sending call. Store 0 in Registro if not reply to call, 1 if receive call and stay active all seconds setting in second parameter, 2 if receive call but called off by remote user"){Wait until In16_1 seconds that user repply to call<br>Call active for In16_2 seconds<br>Recall until In8_1<br>Number to call=[MemIn_1]<br>ROut_1=State of call}-OUTPUT.SendCall
//*********************************************************** Wait Call ************************************************************************************
//PARAMETER
//16 bit that contains seconds to wait incomming call
//16 bit that contains seconds to take active incomming call
//16 bit address of memory where store number of incomming call
//8 bit that contains index of Registro where save state of incomming call. Store 0 in Registro if not receive call, 1 if reply to call and stay active all seconds setting in second parameter, 2 if reply to call but called off by remote user
#define WAIT_CALL 56
#define COMMAND.GSM.WAIT_CALL "Wait incomming call"(In16_1"seconds to wait incomming call",In16_2"seconds to take active incomming call",MemOut_1"16 bit address of memory where store the number of incomming call",ROut_1"index of Registro where save state of incomming call. Store 0 in Registro if not receive call, 1 if reply to call and stay active all seconds setting in second parameter, 2 if reply to call but called off by remote user"){Wait incomming call until In16_1 seconds<br>Call active for In16_2 seconds<br>[MemOut_1]=number of incomming call<br>ROut_1=State call}-JUMP.WaitCall
//-----------------------------------------------------------------------------------------------------------------------------------------------------------

//***************************** Control call state and return state and phone number of incomming call ****************************************************
//PARAMETER
//8 bit that contains index of Registro where store call state (0=existig incomming call, 1=no incomming call)
//16 bit address of memory where store phone number of incomming call
#define CALL_STATE 57
#define COMMAND.GSM.CALL_STATE "State incomming call"(RIn_1"index of Registro register were to store call state. 0=existig incomming call, 1=no incomming call",MemIn_1"16 bit address of memory were to store call phone number"){RIn_1=Call state<br>[MemIn_1]=Phone number}-JUMP.CallState
//---------------------------------------------------------------------------------------------------------------------------------------------------------

//*************************************************** Reply to incomming call *****************************************************************************
#define CALL_REPLY 58
#define COMMAND.GSM.CALL_REPLY "Reply to call"()-OUTPUT.ReplyCall
//---------------------------------------------------------------------------------------------------------------------------------------------------------

//****************************************************** Close active call ********************************************************************************
#define CALL_CLOSE 59
#define COMMAND.GSM.CALL_CLOSE "Close incomming call"()-OUTPUT.CloseCall
//---------------------------------------------------------------------------------------------------------------------------------------------------------

//****************************************************** Automatic call reply *****************************************************************************
#define AUTOMATIC_CALL_REPLY 60
#define COMMAND.GSM.AUTOMATIC_CALL_REPLY "Automatic call reply"(In16_1"number of ring befoure call reply. 0=disable automatic reply"){Automatic reply call after<br>In16_1 rings.<br>0=disable call reply.}-OUTPUT.AutomaticCallReply
//---------------------------------------------------------------------------------------------------------------------------------------------------------


//------------------------------------------ S T R I N G / R E G I S T E R   F U N C T I O N ----------------------------------------------------------------

//*********************************************************** Copy String ************************************************************************************
//PARAMETER
//16 bit address of memory where read source string 1
//16 bit address of memory where read source string 2
//16 bit address of memory where store strings merged
#define MERGE_STRING 70
#define COMMAND.STRING.MERGE_STRING "Merge 2 strings"(MemIn_1"memory address where read 1 string value",MemIn_2"memory address where read 2 string value",MemOut_1"memory address where store strings merged"){String from read 1=[MemIn_1]<br>String from read 2=[MemIn_2]<br>String merged=[MemOut_1]}-OUTPUT.MergeString

//*********************************************************** Copy String ************************************************************************************
//PARAMETER
//8 bit that contains index of Registro register where read integer value to convert
//16 bit address of memory where store string converted
#define INT_TO_STRING 71
#define COMMAND.STRING.INT_TO_STRING "Convert integer to string"(RIn_1"index of Registro register where read integer value to convert",MemOut_1"memory address where store converted value"){[MemOut_1]=RIn_1}-OUTPUT.IntToString

//*********************************************************** Copy String ************************************************************************************
//PARAMETER
//16 bit address of memory where read source string
//16 bit address of memory where store string
#define COPY_STRING 72
#define COMMAND.STRING.COPY_STRING "Copy string"(MemIn_1"memory address where read string value",MemOut_1"memory address where store string"){String from read=[MemIn_1]<br>String to store=[MemOut_1]}-OUTPUT.CopyString

//*********************************************************** Find String ************************************************************************************
//PARAMETER
//16 bit address of memory where read source string
//16 bit address of memory where read string to find
//8 bit that contains index of Registro register where store the position of string finded
//8 bit that contains index of Registro register where store the result of test. Registro=0 if find the string, Registro=1 if not find the string
//8 bit that contains type of search. If 0 test if the 2 string was equal. if 1 test if Stringhe[IndiceStringa2] was included in to Stringhe[IndiceStringa1] and return the position
#define FIND_STRING 73
#define COMMAND.STRING.FIND_STRING "Find string"(MemIn_1"index of Stringhe register that is the source string",MemIn_2"index of Stringhe register that is the string to find",ROut_1"index of Registro register where store the position of string finded",ROut_2"index of Registro register where store the result of test. 0=string finded, 1=string not finded",In8_1(0:test equal string,1: test 2 string is include in to 1 string)"type of search. If 0 test if the 2 string was equal. if 1 test if second string is include in to first string and return the position"){Source string=[MemIn_1]<br>String to find=[MemIn_2]<br>ROut_1=Position of string finded<br>ROut_2=Result of test. 0=string finded, 1=string not finded<br>Type of search=In8_1}-OUTPUT.FindString
#define FIND_STRING_JUMP 73
#define COMMAND.STRING.FIND_STRING_JUMP "Find string"(MemIn_1"index of Stringhe register that is the source string",MemIn_2"index of Stringhe register that is the string to find",ROut_1"index of Registro register where store the position of string finded",ROut_2"index of Registro register where store the result of test. 0=string finded, 1=string not finded",In8_1(0:test equal string,1: test 2 string is include in to 1 string)"type of search. If 0 test if the 2 string was equal. if 1 test if second string is include in to first string and return the position"){Source string=[MemIn_1]<br>String to find=[MemIn_2]<br>ROut_1=Position of string finded<br>ROut_2=Result of test. 0=string finded, 1=string not finded<br>Type of search=In8_1}-JUMP.FindString
//*********************************************************** Cut String ************************************************************************************
//PARAMETER
//16 bit address of memory where read source string
//8 bit that contains index of Registro register where read the start position to cut
//8 bit that contains index of Registro register where read the number of character to cut
//16 bit address of memory where store the string cut
#define CUT_STRING 74
#define COMMAND.STRING.CUT_STRING "Cut string"(MemIn_1"16 bit address of memory where read source string",RIn_1"index of Registro register where read the start position to cut",RIn_2"index of Registro register where read the number of character to cut",MemOut_1"16 bit address of memory where store the string cut"){Source string=[MemIn_1]<br>Start position to cut=RIn_1<br>Character to cut=RIn_2<br>[MemOut_1]=String cutted}-OUTPUT.CutString
//************************************************* Load Register value from Flash with immediate address ***************************************************
//PARAMETER
//8 bit that contains index of Registro to store value
//16 bit that contains address of flash to read value
#define LOAD_MEM_REGISTER_DIRECT 80
#define COMMAND.STRING.LOAD_MEM_REGISTER_DIRECT "Load register from flash"(ROut_1"index of Registro to store value",RegMemIn_1"address to read from flash"){ROut_1=[RegMemIn_1]}-OUTPUT.LoadRegisterFlashByRegister
//************************************************** Store Register value to Flash with immediate address ****************************************************
//PARAMETER
//16 bit that contains address of flash to store register value
//8 bit that contains index of Registro were read thevalue to store
#define STORE_MEM_REGISTER_DIRECT 82
#define COMMAND.STRING.STORE_MEM_REGISTER_DIRECT "Store register to flash"(RegMemOut_1"flash address to store register value",RIn_1"index of Registro were read value to store"){[RegMemOut_1]=RIn_1}-OUTPUT.StoreRegisterFlashByRegister

//*************************************************** Store constant to register ****************************************************************************
//PARAMETER
//8 bit that contains index of Registro register were store constant value
//16 bit that contains constant value to store in Registro register
#define LOAD_CONST_REGISTER 83
#define COMMAND.STRING.LOAD_CONST_REGISTER "Store constant to register"(ROut_1"index of Registro register were store constant value",In16_1"constant value to store in Registro register"){ROut_1=In16_1}-OUTPUT.ConstantToRegister
//-----------------------------------------------------------------------------------------------------------------------------------------------------------

//************************************************* Load value to register from vector ***************************************************
//PARAMETER
//8 bit that contains index of Registro to store value
//16 bit that contains base address of flash to read value
//8 bit that contains index of Registro to read index of vector
#define LOAD_VECTOR_REGISTER 84
#define COMMAND.STRING.LOAD_VECTOR_REGISTER "Load vector value to register"(ROut_1"register to store value",RegMemVectIn_1"vector name to read from flash",RIn_1"register value were read index of vector"){ROut_1=[RegMemVectIn_1(RIn_1)]}-OUTPUT.LoadRegisterFlashByRegister

//************************************************** Store resgister value to vector ****************************************************
//PARAMETER
//16 bit that contains base address of flash to store vector value
//8 bit that contains index of Registro were read the value to store
//8 bit that contains index of Registro to read index of vector
#define STORE_VECTOR_REGISTER 85
#define COMMAND.STRING.STORE_VECTOR_REGISTER "Store register value to vector"(RegMemVectOut_1"vector name to store register value",RIn_1"register were read value to store",RIn_2"register value were read index of vector"){[RegMemVectOut_1(RIn_2)]=RIn_1}-OUTPUT.StoreRegisterFlashByRegister

//************************************************* Load vector value to string ***************************************************
//PARAMETER
//8 bit that contains index of Registro to store value
//16 bit that contains base address of flash to read value
//8 bit that contains index of Registro to read index of vector
#define LOAD_VECTOR_STRING 86
#define COMMAND.STRING.LOAD_VECTOR_STRING "Load vector value to string"(MemOut_1"string name to store vector value",StringMemVectIn_1"vector name to read string",RIn_1"register value were read index of vector"){MemOut_1=[StringMemVectIn_1(RIn_1)]}-OUTPUT.LoadRegisterFlashByRegister

//************************************************** Store string to vector ***************************************************
//PARAMETER
//16 bit that contains base address of flash to store vector value
//8 bit that contains index of Registro were read the value to store
//8 bit that contains index of Registro to read index of vector
#define STORE_VECTOR_STRING 87
#define COMMAND.STRING.STORE_VECTOR_STRING "Store string to vector"(StringMemVectOut_1"vector name to store string",MemIn_1"string name were read value to store",RIn_1"register value were read index of vector"){[StringMemVectOut_1(RIn_1)]=MemIn_1}-OUTPUT.StoreRegisterFlashByRegister


//--------------------------------------------- A R I T M E T I C   F U N C T I O N -------------------------------------------------------------------------
//************************************************************ Sum ******************************************************************************************
//PARAMETER
//8 bit that contains index of Registro register were read 1 addend
//8 bit that contains index of Registro register were read 2 addend
//8 bit that contains index of Registro register where store the result of sum
//8 bit that contains index of Registro register where store the state of sum. Registro=0 if the result not generate overflow, Registro=1 if generate overflow
#define SUM_REGISTER 100
#define COMMAND.ARITHMETIC.SUM_REGISTER "Sum register"(RIn_1"index of Registro register were read 1 addend",RIn_2"index of Registro register were read 2 addend",ROut_1"index of Registro register where store the result of sum",ROut_2"index of Registro register where store the state of sum. Registro=0 if the result not generate overflow, Registro=1 if generate overflow"){ROut_1=RIn_1+RIn_2<br>Overflow=ROut_2}-OUTPUT.Sum
//********************************************************* Subtraction ************************************************************************************
//PARAMETER
//8 bit that contains index of Registro register were read 1 subtractiong
//8 bit that contains index of Registro register were read 2 subtracting
//8 bit that contains index of Registro register where store the result of subtraction
//8 bit that contains index of Registro register where store the state of subtraction. Registro=0 if the result not generate overflow, Registro=1 if generate overflow
#define SUB_REGISTER 101
#define COMMAND.ARITHMETIC.SUB_REGISTER "Subtract register"(RIn_1"index of Registro register were read 1 subtracting",RIn_2"index of Registro register were read 2 subtracting",ROut_1"index of Registro register where store the result of subtraction",ROut_2"index of Registro register where store the state of subtraction. Registro=0 if the result not generate overflow, Registro=1 if generate overflow"){ROut_1=RIn_1-RIn_2<br>Overflow=ROut_2}-OUTPUT.Sub
//********************************************************** Division **************************************************************************************
//PARAMETER
//8 bit that contains index of Registro register were read 1 dividend
//8 bit that contains index of Registro register were read 2 dividend
//8 bit that contains index of Registro register where store the result of division
//8 bit that contains index of Registro register where store the state of division. Registro=0 if the result not generate overflow, Registro=1 if generate overflow
#define DIV_REGISTER 102
#define COMMAND.ARITHMETIC.DIV_REGISTER "Divide register"(RIn_1"index of Registro register were read 1 dividend",RIn_2"index of Registro register were read 2 dividend",ROut_1"index of Registro register where store the result of division",ROut_2"index of Registro register where store the state of division. Registro=0 if the result not generate overflow, Registro=1 if generate overflow"){ROut_1=RIn_1\RIn_2<br>Overflow=ROut_2}-OUTPUT.Div
//******************************************************** Multiplication **********************************************************************************
//PARAMETER
//8 bit that contains index of Registro register were read 1 multiplaiyng
//8 bit that contains index of Registro register were read 2 multiplaiyng
//8 bit that contains index of Registro register where store the result of multiplaiyng
//8 bit that contains index of Registro register where store the state of multiplaiyng. Registro=0 if the result not generate overflow, Registro=1 if generate overflow
#define MUL_REGISTER 103
#define COMMAND.ARITHMETIC.MUL_REGISTER "Multiply register"(RIn_1"index of Registro register were read 1 multiplaiyng",RIn_2"index of Registro register were read 2 multiplaiyng",ROut_1"index of Registro register where store the result of multiplaiyng",ROut_2"index of Registro register where store the state of multiplaiyng. Registro=0 if the result not generate overflow, Registro=1 if generate overflow"){ROut_1=RIn_1xRIn_2<br>Overflow=ROut_2}-OUTPUT.Multiply
//----------------------------------------------------------------------------------------------------------------------------------------------------------
//******************************************************** OR *********************************************************************************************
//PARAMETER
//8 bit that contains index of Registro register were read 1 value
//8 bit that contains index of Registro register were read 2 value
//8 bit that contains index of Registro register where store the result of OR
#define OR_REGISTER 104
#define COMMAND.ARITHMETIC.OR_REGISTER "OR register"(RIn_1"index of Registro register were read 1 value",RIn_2"index of Registro register were read 2 value",ROut_1"index of Registro register where store the result of OR"){ROut_1=RIn_1&RIn_2}-OUTPUT.OR
//----------------------------------------------------------------------------------------------------------------------------------------------------------
//******************************************************** AND *******************************************************************************************
//PARAMETER
//8 bit that contains index of Registro register were read 1 value
//8 bit that contains index of Registro register were read 2 value
//8 bit that contains index of Registro register where store the result of AND
#define AND_REGISTER 105
#define COMMAND.ARITHMETIC.AND_REGISTER "AND register"(RIn_1"index of Registro register were read 1 value",RIn_2"index of Registro register were read 2 value",ROut_1"index of Registro register where store the result of AND"){ROut_1=RIn_1&RIn_2}-OUTPUT.AND
//----------------------------------------------------------------------------------------------------------------------------------------------------------



//---------------------------------------------------- T E S T   F U N C T I O N ---------------------------------------------------------------------------
//*************************************************** Test if 2 register is equal **************************************************************************
//PARAMETER
//8 bit that contains index of Registro register were read first value for test
//8 bit that contains index of Registro register were read second value for test
//16 bit that contains address to jump. If the 2 register is equal jump else not jump
#define IF_EQUAL 120
#define COMMAND.TEST.IF_EQUAL "Test if 2 register is equal"(RIn_1"index of Registro register were read first value for test",RIn_2"index of Registro register were read second value for test",J16_1"Address to jump"){if RIn_1=RIn_2<br>Jump to J16_1}-JUMP.Equal
//******************************************* Test if register 1 is greater of register 2 ******************************************************************
//PARAMETER
//8 bit that contains index of Registro register were read first value for test
//8 bit that contains index of Registro register were read second value for test
//16 bit that contains address to jump. If the 1 register is greater of 2 register jump else not jump
#define IF_GREATER 121
#define COMMAND.TEST.IF_GREATER "Test if 1 register > 2 register"(RIn_1"index of Registro register were read first value for test",RIn_2"index of Registro register were read second value for test",J16_1"Address to jump"){if RIn_1>RIn_2<br>Jump to J16_1}-JUMP.Greater
//******************************************** Test if register 1 is minor of register 2 *******************************************************************
//PARAMETER
//8 bit that contains index of Registro register were read first value for test
//8 bit that contains index of Registro register were read second value for test
//16 bit that contains address to jump. If the 1 register is minor of 2 register jump else not jump
#define IF_MINOR 122
#define COMMAND.TEST.IF_MINOR "Test if 1 register &lt; 2 register"(RIn_1"index of Registro register were read first value for test",RIn_2"index of Registro register were read second value for test",J16_1"Address to jump"){if RIn_1&lt;RIn_2<br>Jump to J16_1}-JUMP.Smaller
//---------------------------------------------------------------------------------------------------------------------------------------------------------



//-------------------------------------------------- U S B   F U N C T I O N ------------------------------------------------------------------------------
//****************************************************** Turn ON USB **************************************************************************************
#define USB_ON 140
#define COMMAND.USB.USB_ON "USB turn ON"()-OUTPUT.USBOn
//***************************************************** Turn OFF USB **************************************************************************************
#define USB_OFF 141
#define COMMAND.USB.USB_OFF "USB turn OFF"()-OUTPUT.USBOff
//****************************************** Sending data to USB from Stringhe register *******************************************************************
//PARAMETER
//16 bit address of memory were read the string to send
#define TX_USB 142
#define COMMAND.USB.TX_USB "USB send data"(MemIn_1"16 bit address of memory were read the string to send"){String to send=[MemIn_1]}-OUTPUT.USBSend
//************************************* Receive data from USB and store to Stringhe register **************************************************************
//PARAMETER
//16 bit address of memory were store USB received byte
//8 bit that contains index of Registro register were read value in msec of inactivity timeout. If 0 not consider timeout
//8 bit that contains index of Registro register were read a char for exit to reception
#define RX_USB 143
#define COMMAND.USB.RX_USB "USB receive data"(MemOut_1"16 bit address of memory were store USB received byte",RIn_1"index of Registro register were read value in msec of inactivity timeout. If 0 not consider timeout",RIn_2"index of Registro register were read a char for exit to reception"){[MemIn_1]=String<br>Inactivity timeout=RIn_1<br>Char to exit=RIn_2}-OUTPUT.USBReceive
//---------------------------------------------------------------------------------------------------------------------------------------------------------



//--------------------------------------------- P O W E R   D O W N   F U N C T I O N ---------------------------------------------------------------------
//*************************************** Power Down microcontroller an activate interrupt ****************************************************************
//PARAMETER
//8 bit that contains input where activate interrupt
//bit 0= IN1
//bit 1= IN2
//bit 4= IN5
//bit 6= SW1
//bit 7= SW2
//8 bit where if value=1 exit from sleep every 128msec.
#define PW_DOWN 160
#define COMMAND.PWDOWN.PW_DOWN "Power down"(In8_1(1: IN1,2: IN2,16: IN5,64: SW1,128: SW2,3: IN1-IN2,17: IN1-IN5,65: IN1-SW1,129: IN1-SW2,66: IN2-1,130: IN2-SW2,80: IN5-SW1,192: SW1-SW2,19: IN1-IN2-IN5,67: IN1-IN2-SW1,131: IN1-IN2-SW2,81: IN1IN5-SW1,145: IN1-IN5-SW2,193: IN1-SW1-SW2,194: IN2-SW1-SW2,208: IN5-SW1-SW2)"8 bit that contains input where activate interrupt",In8_2(0: stay in sleep until input interrupt,1: exit from sleep every 128ms)"8 bit where if value=1 exit from sleep every 128msec"){Activated interrupt=In8_1<br>Type of power down=In8_2}-JUMP.Sleep
//---------------------------------------------------------------------------------------------------------------------------------------------------------


//-------------------------------------------------- T I M E R   F U N C T I O N --------------------------------------------------------------------------
//******************************************************** Power on timer *********************************************************************************
//8 bit that contains index of Registro where contain value of timer
//timer increment every 10msec
#define TIMER_ON 170
#define COMMAND.TIMER.TIMER_ON "Timer ON"(RIn_1"index of Registro where contain value of timer. This value will be increment every 10msec."){RIn_1=Time}-OUTPUT.TimerOn
//---------------------------------------------------------------------------------------------------------------------------------------------------------

//******************************************************* Power off timer *********************************************************************************
#define TIMER_OFF 171
#define COMMAND.TIMER.TIMER_OFF "Timer OFF"()-OUTPUT.TimerOff
//---------------------------------------------------------------------------------------------------------------------------------------------------------

//-------------------------------------------------- C H E C K   B A T T E R Y --------------------------------------------------------------------------
//******************************************************** Power on timer *********************************************************************************
//8 bit that contains index of Registro where store battery value*10V
#define CHECK_BATTERY 180
#define COMMAND.CHECKBATTERY.CHECK_BATTERY "Battery value"(RIn_1"index of Registro where store battery value"){RIn_1=Battery value}-OUTPUT.CheckBatteryValue
//---------------------------------------------------------------------------------------------------------------------------------------------------------

//-------------------------------------------------- B E E P   F U N C I O N ------------------------------------------------------------------------------
//******************************************************** Type of sound **********************************************************************************
//8 bit for select type of sound (0=beep, 1=beep ok, 2=bepp error)
#define BEEP 190
#define COMMAND.SOUND.BEEP "Beep"(In8_1(0: Beep,1: Beep OK,2: Beep Error)"select type of sound"){Sound Type=In8_1}-OUTPUT.BeepIcon
//---------------------------------------------------------------------------------------------------------------------------------------------------------



//-------------------------------------------------- C O M P I L E R    F U N C T I O N -------------------------------------------------------------------
//**************************************************** Compiler string length *****************************************************************************
//16 bit string length
#define STRING_LENGTH 198
#define COMMAND.COMPILER.STRING_LENGTH "String length"(In8_1"string length"){String length=In8_1}-OUTPUT.NumbersIcon
//---------------------------------------------------------------------------------------------------------------------------------------------------------

#define TEST_PRODUCTION 199
#define COMMAND.COMPILER.TEST_PRODUCTION "Test all function of board"( RIn_1"register contain result of test. If 0, test succesfully."){RIn_1=test result}-OUTPUT.NumbersIcon

//************************************************* Variables (only for DMDesign) *************************************************************************
#define COMMAND.VARIABLE.number "Define numeric variable"(In16_1"Name of numerical variable"){In16_1}-VARIABLE.NumbersIcon
#define COMMAND.VARIABLE.number_mem "Define numeric constant"(In16_1"Name of constant numeric variable",InRegMem16_1"Start value of variable"){In16_1=InRegMem16_1}-VARIABLE_global.NumbersIcon
#define COMMAND.VARIABLE.number_mem_vector "Define numeric vector"(In16_1"Name of numeric variables vector",In16_2"Length of the vector"){In16_1[0..In16_2]=(0,0,0,...)}-VARIABLE_global.NumbersVectorIcon
//#define COMMAND.VARIABLE.string "Define string variable"(In16_1"Name of string variable"){In16_1}-VARIABLE.StringIcon
#define COMMAND.VARIABLE.string_mem "Define string constant"(In16_1"Name of constant string variable",InMem16_1"Start value of variable"){In16_1=InMem16_1}-VARIABLE_global.StringIcon
#define COMMAND.VARIABLE.string_mem_vector "Define string vector"(In16_1"Name of string variables vector",In16_2"Length of the vector"){In16_1[0..In16_2]=(0,0,0,...)}-VARIABLE_global.StringVectorIcon
#define COMMAND.VARIABLE.- "Jump to state"(J16_1"State to jump"){Main state=J16_1}-STATE

//---------------------------------------------------------------------------------------------------------------------------------------------------------

#define GROUP.LED "LED function"
#define GROUP.JUMP "Jump function"
#define GROUP.DELAY "Delay function"
#define GROUP.IO "Input/Output function"
#define GROUP.GSM "GSM function"
#define GROUP.STRING "String/Register function"
#define GROUP.ARITHMETIC "Arithmetic function"
#define GROUP.TEST "Test function"
#define GROUP.USB "USB function"
#define GROUP.PWDOWN "Power Down function"
#define GROUP.TIMER "Timer function"
#define GROUP.VARIABLE "Variable function"
#define GROUP.CHECKBATTERY "Battery function"
#define GROUP.SOUND "Beep function"
//#define GROUP.COMPILER "Compiler function"
